/// <reference types="react" />
import * as echarts from 'echarts';
declare type EChartsInitType = typeof echarts.init;
export declare type EChartsType = typeof echarts;
export declare type EChartsCoreOption = echarts.EChartsCoreOption;
export declare type EChartsOption = echarts.EChartsOption;
export declare type EChartsTheme = Parameters<EChartsInitType>['1'];
export declare type EChartsInitOpts = Parameters<EChartsInitType>['2'];
export declare type EchartsInstance = echarts.EChartsType;
export interface EChartsSetOptionOpts {
    notMerge?: boolean;
    lazyUpdate?: boolean;
    silent?: boolean;
    replaceMerge?: string | string[];
}
export interface EChartsLoadingConfig {
    type?: 'default';
    opts?: object;
}
export interface EChartsCoreProps<O extends EChartsCoreOption = EChartsOption> {
    echarts: any;
    className?: string;
    style?: React.CSSProperties;
    option?: O;
    theme?: EChartsTheme;
    initOpts?: EChartsInitOpts;
    setOptionOpts?: EChartsSetOptionOpts;
    autoResize?: boolean;
    loading?: boolean;
    loadingConfig?: EChartsLoadingConfig;
    group?: string;
    onChartInit?: (echartsInstance: EchartsInstance) => void;
    onEvents?: {
        [eventName: string]: (event: any) => void;
    };
}
export interface EChartsRef {
    echartsInstance: EchartsInstance;
}
export {};
